/**
 *  WS2811Driver.cpp - driver class implementation for the ws2811 rgb led controller IC.
 *  Supports MSP430G2 and MSP430F5529 Launchpads set t 16MHz.
 *
 *  Copyright (C) 2012  Rick Kimball rick@kimballsoftware.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Sections of code used from the AdaFruit NeoPixel library:
 *
 *  Written by Phil Burgess / Paint Your Dragon for Adafruit Industries,
 *  contributions by PJRC and other members of the open source community.

 *  Adafruit invests time and resources providing this open source code,
 *  please support Adafruit and open-source hardware by purchasing products
 *  from Adafruit!
 *
 * 09-02-2014
 */

#ifndef WS2811DRIVER_H_
#define WS2811DRIVER_H_

#define LED_PORT		GPIO_PORT_P3
#define LED_PIN			GPIO_PIN0
#define LED_TOTAL		69
#define LED_ORDER		1	// 0 - RGB; 1 - GRB; 2 - BRG

void ledBegin(void);
void ledEnd(void);
void ledShow(void);
void setPixelRGB(uint16_t n, uint8_t r, uint8_t g, uint8_t b);
void setPixelColor(uint16_t n, uint32_t c);
uint32_t Color(uint8_t r, uint8_t g, uint8_t b);
uint16_t numPixels(void);
void setBrightness(uint8_t);

#endif /* WS2811DRIVER_H_ */
