﻿//#define SHOW_MESSAGES

using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.NetworkInformation;
using com.animiku.first.smartdashboardlib;
using System.Threading;

namespace dashboard2015
{
    public partial class Form1 : Form
    {
        const string keyName = "HKEY_CURRENT_USER\\Dashboard";
        const string valueName = "TeamID";
        const string AUTO_CHOICE = "auto_choice";
        const string AUTO_SWITCH = "auto_switch";
        const string AUTO_DESCRIPTION = "auto_description";
        const string LIFTER_POSITION = "lifter_position";
        const string GRIPPER_POSITION = "gripper_position";
        const string MATCH_TIME = "match_time";
        const string MATCH_YIKES = "match_yikes";

        //AForge.Video.MJPEGStream cameraFeed = null;
        bool formClosing = false;
        SmartDashboard dash = null;
        bool firstDashboard = true;
        //Thread cameraThread;
		BackgroundWorker bw;	//MAB - added so it is a class object
		BackgroundWorker bw1;	//MAB - added so it is a class object

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            //spamButton is used for testing the different meter controls. Right now it is set to be invisible.
            spamButton.Visible = false;
            Location = new Point(0, 0);

            //Sets the Drive forward button as default
            InternalAutoModeRadioButton.Checked = true;
            AutoModeNumericUpDown.Enabled = false;

            // Get the last used team number from the registry for default value.
            reconnect(false);
            bw = new BackgroundWorker();														//MAB - is now a class object
			bw.DoWork += new DoWorkEventHandler(cameraControl.StartConnection);
            //bw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(bw_RunWorkerCompleted);
			cameraControl.port = 1180;															//MAB - so we can have two feeds
            cameraControl.cameraIp = GetRobotIP();	//MAB - must be before thread is started
			cameraControl.statusTextBox = statusTextBox;										//MAB - must be before thread is started
			bw.RunWorkerAsync(cameraControl);
            //var cameraThreadStart = new ParameterizedThreadStart(cameraControl.StartConnection);
            //cameraThread = new Thread(cameraThreadStart);
            //MAB (moved) cameraControl.cameraIp = ConvertTeamNumberToIP((int)teamNumberNumericUpDown.Value);
			//MAB (moved) cameraControl.statusTextBox = statusTextBox;
            //cameraThread.Start(cameraControl);

			//MAB - added the following to support two cameras
#if !foo
			bw1 = new BackgroundWorker();
			bw1.DoWork += new DoWorkEventHandler(cameraControl1.StartConnection);
			cameraControl1.port = 5800;
            cameraControl1.cameraIp = GetRobotIP();
			cameraControl1.statusTextBox = statusTextBox;
			bw1.RunWorkerAsync(cameraControl1);
#endif
		}

        void bw_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            throw new NotImplementedException();
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (InternalAutoModeRadioButton.Checked)
                AutoModeNumericUpDown.Enabled = false;
            else if (DoNothingAutoModeRadioButton.Checked)
                AutoModeNumericUpDown.Enabled = false;
            else //When ChooseAutoModeRadioButton is selected
                AutoModeNumericUpDown.Enabled = true;

        }

        private void spamButton_Clicked(object sender, EventArgs e)
        {
            leftGripperBar.Value = 20;
            rightGripperBar.Value = 20;
            lifterBar.Value = 20;
            System.Threading.Thread.Sleep(5000);

            leftGripperBar.Value = 30;
            rightGripperBar.Value = 30;
            lifterBar.Value = 30;
            //System.Threading.Thread.Sleep(5000);
            
            leftGripperBar.Value = 40;
            rightGripperBar.Value = 40;
            lifterBar.Value = 40;
            System.Threading.Thread.Sleep(5000);

            leftGripperBar.Value = 50;
            rightGripperBar.Value = 50;
            lifterBar.Value = 50;
            System.Threading.Thread.Sleep(1000);

            leftGripperBar.Value = 60;
            rightGripperBar.Value = 60;
            lifterBar.Value = 60;
            System.Threading.Thread.Sleep(1000);

            leftGripperBar.Value = 70;
            rightGripperBar.Value = 70;
            lifterBar.Value = 70;
            System.Threading.Thread.Sleep(1000);

            leftGripperBar.Value = 80;
            rightGripperBar.Value = 80;
            lifterBar.Value = 80;
            System.Threading.Thread.Sleep(1000);

            leftGripperBar.Value = 90;
            rightGripperBar.Value = 90;
            lifterBar.Value = 90;
            System.Threading.Thread.Sleep(1000);

            leftGripperBar.Value = 100;
            rightGripperBar.Value = 100;
            lifterBar.Value = 100;
            System.Threading.Thread.Sleep(1000);
        }

                private void ShowMessage(string msg)
        {
#if SHOW_MESSAGES
            MessageBox.Show(msg);
#endif
        }

        private string GetRobotIP()
        {           
            return "roborio-1511.local";
            //For testing purposes with the network table viewer
            //return "127.0.0.1";
        }

        private bool PingRobot(string address)
        {
            Ping ping = new Ping();
            PingOptions pingOptions = new PingOptions();
            pingOptions.DontFragment = true;
            // Create buffer of 32 bytes of data to be transmitted.
            string data = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";
            byte[] buffer = Encoding.ASCII.GetBytes(data);
            int timeout = 120;  // this is milliseconds
            try
            {
                PingReply reply = ping.Send(address, timeout, buffer, pingOptions);
                if (reply.Status == IPStatus.Success)
                {
                    // Ping was successful
                    statusTextBoxC.Text = "ping ok";

                    return (true);
                }
                // Ping failed
            }
            catch
            {
                // mostly HOST not found
                statusTextBoxC.Text = "At " + DateTime.Now + " Failed while pinging";

            }
            return (false);
        }

        public void reconnect(bool ipChanged)
        {
            // stop trying to reconnect if we are closing
            if (formClosing)
            {
                return;
            }
            //networktables will call disconnected when it is first linked
            //and it is not connected
            //set this to true, so disconnected will ignore if it is called as soon as it is linked
            firstDashboard = true;
            if (dash != null)
            {
                ShowMessage("disconnecting");
                // do clean-up
                dash.disconnect();
                dash = null;
            }

            // first make sure the robot is even alive
            if (PingRobot(GetRobotIP()))
            {
                ShowMessage("newing it up NULL");
                dash = new SmartDashboard(GetRobotIP());

                ShowMessage("newed up ");

                if (dash != null)
                {
                    try
                    {
                        ShowMessage("trying ");
                        dash.linkClassToConnectionListener(this);
                        statusTextBoxC.Text = "connected";
                    }
                    catch
                    {
                        ShowMessage("link fail");
                        dash = null;
                        statusTextBoxC.Text = "At " + DateTime.Now + " Failed while linking";
                    }
                }
            }
            else
            {
                ShowMessage("robot is not there: " + GetRobotIP());
            }

            if (dash == null)
            {
                ShowMessage("in reconnect NULL");
                timerConnect.Start();
                timerConnect.Enabled = true;
            }
            Text = "2015 Dashboard (1511)";
        }

        private delegate void ConnectedDelegate();
        public void connected()
        {
            if (InvokeRequired)
            {
                BeginInvoke(new ConnectedDelegate(connected), new object[] { });
                return;
            }
            firstDashboard = false;
            timerConnect.Enabled = false;
            timerConnect.Stop();

            ShowMessage("Connected");
            this.Connectionbox.BackColor = Color.LimeGreen;
            if (dash != null)
            {
                dash.linkClassToTableListener(this);
                dash.putDouble(AUTO_CHOICE, (double)AutoModeNumericUpDown.Value);
            }
        }

        private delegate void DisconnectedDelegate();
        public void disconnected()
        {
            if (InvokeRequired)
            {
                BeginInvoke(new DisconnectedDelegate(disconnected), new object[] { });
                return;
            }

            if (firstDashboard)
            {
                firstDashboard = false;
                return;
            }

            ShowMessage("disconnected");
            if (dash != null)
            {
                dash.clearConnectionListener();
                dash.clearTableListener();
            }
            dash = null;
            timerConnect.Enabled = true;
            timerConnect.Start();
            this.Connectionbox.BackColor = Color.Red;
        }

        private delegate void ValueChangedDelegate(String key, object value, bool isNew);
        public void valueChanged(String key, object value, bool isNew)
        {
            if (InvokeRequired)
            {
                BeginInvoke(new ValueChangedDelegate(valueChanged), new object[] { key, value, isNew });
                return;
            }

            double dValue;
            switch (key)
            {
                case LIFTER_POSITION:
                    dValue = Convert.ToDouble(value.ToString()) * 100; 
                    lifterBar.Value = Convert.ToInt32(dValue);
                    break;
                case GRIPPER_POSITION:
                    dValue = Convert.ToDouble(value.ToString()) * 100;
                    leftGripperBar.Value = Convert.ToInt32(dValue);
                    rightGripperBar.Value = Convert.ToInt32(dValue);
                    break;
                case AUTO_DESCRIPTION:
                    autoModeDescriptionsBox.Text = (string)value;
                    break;
                case AUTO_SWITCH:
                    dValue = Convert.ToDouble(value.ToString()); 
                    switch (Convert.ToInt32(dValue))
                    {   
                        case 0:
                            InternalAutoModeRadioButton.Checked = true;
                            InternalAutoModeRadioButton.Enabled = true;
                            ChooseAutoModeRadioButton.Enabled = false;
                            DoNothingAutoModeRadioButton.Enabled = false;
                            break;
                        case 1:
                        default:
                            InternalAutoModeRadioButton.Enabled = false;
                            ChooseAutoModeRadioButton.Enabled = false;
                            DoNothingAutoModeRadioButton.Checked = true;
                            DoNothingAutoModeRadioButton.Enabled = true;
                            break;
                        case 2:
                            InternalAutoModeRadioButton.Enabled = false;
                            ChooseAutoModeRadioButton.Checked = true;
                            ChooseAutoModeRadioButton.Enabled = true;
                            DoNothingAutoModeRadioButton.Enabled = false;

                            break;
                    }
                    break;
                case AUTO_CHOICE:
                    dValue = Convert.ToDouble(value.ToString());
                    AutoModeNumericUpDown.Value = Convert.ToInt32(dValue);
                    break;
                case MATCH_TIME:
                    dValue = Convert.ToDouble(value.ToString());
                    timerLabel.Text = Convert.ToInt32(dValue).ToString();
                    break;
                case MATCH_YIKES:
                    dValue = Convert.ToDouble(value.ToString());
                    if (dValue > 0)
                    {
                        timerLabel.BackColor = Color.Yellow;
                    }   
                    else
                    {
                        timerLabel.BackColor = Color.White;
                    }
                    break;
                default:
                    // key change not relevant to the dashboard
                    break;
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            formClosing = true;
            ShowMessage("form closing " + e.CloseReason.ToString() + " " + ((dash == null) ? "null" : "not null"));

            timerCamera.Stop();
            timerConnect.Stop();

            if ((dash != null) && dash.isConnected())
                dash.disconnect();

            cameraControl.EndConnection();

            System.Diagnostics.Process[] self = System.Diagnostics.Process.GetProcessesByName("Dashboard2015");
            foreach (System.Diagnostics.Process weejus in self)
            {
                ShowMessage("DEATH TO ALL");
                weejus.Kill();
            }
        }

        private void timerCamera_Tick(object sender, EventArgs e)
        {
            timerCamera.Stop();
            //reconnectCamera(false);
        }

        private void timerConnect_Tick(object sender, EventArgs e)
        {
            timerConnect.Stop();
            reconnect(false);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        private void AutoModeNumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (dash != null)
            {
                dash.putDouble(AUTO_CHOICE, (double)AutoModeNumericUpDown.Value);
            }
        }

        private void refreshButton_Click(object sender, EventArgs e)
        {
            // Close the existing camera connection
            //statusTextBox.Text = "";
            //cameraControl.EndConnection();

            //cameraThread.Join();
            // Restart the camera connection
            //var cameraThreadStart = new ParameterizedThreadStart(cameraControl.StartConnection);
            //cameraThread = new Thread(cameraThreadStart);
            //cameraControl.cameraIp = ConvertTeamNumberToIP((int)teamNumberNumericUpDown.Value);
            //cameraControl.statusTextBox = statusTextBox;
            //cameraThread.Start(cameraControl);
        }

        private void cameraControl_Click(object sender, EventArgs e)
        {

        }

        private void cameraControl1_Click(object sender, EventArgs e)
        {

        }

        private void tableLayoutPanel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void tableLayoutPanel2_Paint(object sender, PaintEventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }
    }
}
