#include "Adafruit_NeoPixel.h"

#define PIN 7
#define NUMPIXELS 157

Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

bool noSignal = true;
bool blinkStateOff = false;
bool humanBlinkState = false;
bool StartScreen = false;
bool lastLeftPos = false; 
bool ballDirectionLeft = false;
bool ballDirectionUp = true;
bool rightScore = false;
bool leftScore = false;

unsigned long timeLosingSignal = 0;
unsigned long timeForCenterWheel = 0;
unsigned long timeForPongStart = 0;
unsigned long timeForLeftPaddle = 0;
unsigned long timeForRightPaddle = 0;
unsigned long timeForHumanButton = 0;
unsigned long timeForBallMove = 0;
unsigned long timeForGameWin = 0;

int time;
int incomingByte = 0;
int xBallPos = 0;
int yBallPos = 0;
int deltaX = 1;
int deltaY = 1;
int leftPoints = 0;
int rightPoints = 0;


int teamNumberOneA[] = {0,1,2,36,39,74,77,112,113,115,-1};
int teamNumberOneB[] = {14,12,13,24,51,62,89,100,101,127,-1};
int teamNumberOneC[] = {16,17,18,20,55,58,93,96,97,131,-1};
int teamNumberFive[] = {4,5,6,31,44,69,70,71,80,109,118,119,120,-1};
int teamNumberLightning[] = {8,28,29,47,48,65,66,84,85,103,104,124,-1};

int PongP[] = {0,37,38,73,74,75,76,79,110,113,114,115,116,-1};
int PongO[] = {6,7,29,32,43,46,67,70,81,84,105,108,120,121,-1};
int PongN[] = {10,13,24,27,48,50,51,62,63,65,86,87,89,100,102,103,124,127,-1};
int PongG[] = {16,17,19,22,53,55,56,60,91,95,98,130,131,-1};

int Elliot[] = {0,1,2,4,6,8,11,12,16,21,24,27,29,31,33,37,38,42,44,46,48,51,54,59,62,65,67,69,71,74,75,76,80,82,84,86,89,91,
92,93,97,100,103,107,109,113,114,115,116,118,120,122,125,126,130,-1};

int Chris[] = {1,2,4,7,9,13,15,16,20,24,28,30,33,37,38,42,45,47,51,55,59,62,66,68,71,75,76,80,81,82,85,86,89,91,98,102,104,109,113,115,116,118,123,127,130,131,-1};

int humanLights[] = {145,146,147,148,149,150,151,152,153,154,155,156,157,-1};

int wheelDown = false;

#define USE_SERIAL

void setup() {
#if defined (__AVR_ATtiny85__)
  if (F_CPU == 16000000) clock_prescale_set(clock_div_1);
#endif

  pinMode(13, OUTPUT);

#ifdef USE_SERIAL
  Serial1.begin(9600);
//  DDRD = DDRD & 0xFB;
//  PORTD = PORTD | 0x04;
#endif
  pixels.begin();
  // put your setup code here, to run once:

}

int leftPosition = 2;
int rightPosition = 2;
int RightPaddleUp = 0;
int RightPaddleDown = 0;int LeftPaddleUp = 0;
int LeftPaddleDown = 0;
int LifterPos = 1;
int GripperPos = 1;
bool Gear = false;
bool PongMode = false;
bool HumanPlayerButton = false;
bool led = false;
unsigned long deltaBall = 250;


void loop() {
  
#ifdef USE_SERIAL
    if(Serial1.available() > 0) {
        incomingByte = Serial1.read();
        noSignal = false;
        
        if (led == false)
        {
          digitalWrite(13,HIGH);
          led = true;
        }
        else
        {
          digitalWrite(13,LOW);
          led = false;
        }
        
        if ((incomingByte & 0x01) == 0)
        {
           int WheelByte = incomingByte & 0x02;
          if (WheelByte == 2)
            wheelDown = true;
          else
            wheelDown = false;
            
          int LifterByte = incomingByte & 0x1C;
          LifterByte = LifterByte >> 2;
          LifterPos = LifterByte;
          
          int GripperByte = incomingByte &  0xE0;
          GripperByte = GripperByte >> 5;
          GripperPos = GripperByte;
        }
        else if ((incomingByte & 0x01) == 1)
        {
          int GearByte = incomingByte & 0x02;
          if (GearByte != 0)
              Gear = true;
          else
              Gear = false;
              
          int PongByte = incomingByte & 0x04;
          if (PongByte == 4) {
              if (PongMode == false) {
                FullReset();
              }
              PongMode = true;
          }
          else
              PongMode = false;
          
          int HumanByte = incomingByte & 0x80;
          if (HumanByte == 128)
              HumanPlayerButton = true;
          else
              HumanPlayerButton = false;
       
          int RightByteDown = incomingByte & 0x08;
          if (RightByteDown == 8)
              RightPaddleDown = true;
          else
              RightPaddleDown = false;
         
          int RightByteUp = incomingByte & 0x10;
          if (RightByteUp == 16)
            RightPaddleUp = true;
          else
            RightPaddleUp = false;
            
          int LeftByteDown = incomingByte & 0x20;
          if (LeftByteDown == 32)
            LeftPaddleDown = true;
          else
            LeftPaddleDown = false;
            
          int LeftByteUp = incomingByte & 0x40;
          if (LeftByteUp == 64)
            LeftPaddleUp = true;
          else
            LeftPaddleUp = false;
              
        }     
        for (int AllPixels = 0; AllPixels < 165; AllPixels++) {
          pixels.setPixelColor(AllPixels, pixels.Color(0, 0, 0));
          
          
        }
        if(leftPoints == 4||rightPoints == 4) {
          WinnerScreen();
        }
        else if (PongMode) {
          PongGame();
        }
        else {
          Row(LifterPos);
          Column(GripperPos);
          GearM(Gear);
          HumanButton(HumanPlayerButton);
        }
      
        //if (incomingByte & 1)
         //   pixels.setPixelColor(137, pixels.Color(255,0,0));
        //if (incomingByte & 2)
          //  pixels.setPixelColor(138, pixels.Color(255,0,0));
        //if (incomingByte & 4)
          //  pixels.setPixelColor(139, pixels.Color(255,0,0));
        //if (incomingByte & 8)
          //  pixels.setPixelColor(140, pixels.Color(255,0,0));
        //if (incomingByte & 16)
        //    pixels.setPixelColor(141, pixels.Color(255,0,0));
        //if (incomingByte & 32)
        //    pixels.setPixelColor(142, pixels.Color(255,0,0));
        //if (incomingByte & 64)
        //    pixels.setPixelColor(143, pixels.Color(255,0,0));
        //if (incomingByte & 128)
        //    pixels.setPixelColor(144, pixels.Color(255,0,0)); 
        
        pixels.show();
    }
   else {
     if(noSignal == false) {
       noSignal = true;
       timeLosingSignal = millis();
     }
#endif
     if (millis() > timeLosingSignal + 1500) {
       for (int AllPixels = 0; AllPixels < 165; AllPixels++) {
       pixels.setPixelColor(AllPixels, pixels.Color(0, 0, 0));
       }
     for (int idxA=0;teamNumberOneA[idxA] != -1;idxA++) {
       pixels.setPixelColor(teamNumberOneA[idxA], pixels.Color(150,0,0));
     }
     for (int idxB=0;teamNumberOneB[idxB] != -1;idxB++) {
       pixels.setPixelColor(teamNumberOneB[idxB], pixels.Color(150,0,0));
     }
     for (int idxC=0;teamNumberOneC[idxC] != -1;idxC++) {
       pixels.setPixelColor(teamNumberOneC[idxC], pixels.Color(150,0,0));
     }
     for (int idxD=0;teamNumberFive[idxD] != -1;idxD++) {
       pixels.setPixelColor(teamNumberFive[idxD], pixels.Color(150,0,0));
     }
      for (int idxE=0;teamNumberLightning[idxE] != -1;idxE++) {
       pixels.setPixelColor(teamNumberLightning[idxE], pixels.Color(255,255,0));
        }
        pixels.show(); 
      }
#ifdef USE_SERIAL
   }
#endif
}

//0-6 rows for the Lifter
void Row(int RowLevel) {
  int StartLED = RowLevel * 19;
  int EndLED = StartLED + 19;

  for (int Pixel = StartLED; Pixel < EndLED; Pixel++) {
    pixels.setPixelColor(Pixel, pixels.Color(0,0,150));
  }
}
//0-7 columns from the center LED Column for the Gripper
void Column(int ColumnLevel) {
  ColumnLevel++;
  if (ColumnLevel > 7) {
    ColumnLevel = 7;
  }
  for (int Row = 0; Row < 7; Row++) {
    int CenterColumn = Row * 19 + 9;
    int First = CenterColumn - ColumnLevel;
    int Last = CenterColumn + ColumnLevel;
    pixels.setPixelColor(First, pixels.Color(150, 0, 0));
    pixels.setPixelColor(Last, pixels.Color(150, 0, 0));
    pixels.setPixelColor(First + 1, pixels.Color(25,0,0));
    pixels.setPixelColor(First - 1, pixels.Color(25,0,0));
    pixels.setPixelColor(Last + 1, pixels.Color(25,0,0));
    pixels.setPixelColor(Last - 1, pixels.Color(25,0,0));
  }
}

  
//24 Leds for Back and Front, Half and half
void GearM(bool GearMode) {
  int StartGearLED = 157 - 24;
  int EndGearLED = 165;
  uint32_t Color;

if (wheelDown == true)
  Color = pixels.Color(150,0,0);
else 
  Color = pixels.Color(0,0,0);
  
  for(int PixelStart = StartGearLED; PixelStart < EndGearLED; PixelStart++) {
    pixels.setPixelColor(PixelStart,Color);
    
  }
}
  // the gear will pick the overall color
 // if (GearMode == true){
   // Color = pixels.Color(0,0,150);
  //}
  //else {
    //Color = pixels.Color(150,0,0);
  //}

  // if wheel is down, then every 1/4 second, turn off the leds
  //if(wheelDown == true) {
    // has 1/4 second past? if so, toggle the blink state
    //if(millis() > (timeForCenterWheel + 250)) {
      //blinkStateOff = !blinkStateOff;
      //timeForCenterWheel = millis();
    //}
    
    // are the leds supposed to be off?
    //if (blinkStateOff == true) {
//      Color = pixels.Color(0,0,0);  // Yes
    //}
//    Color = pixels.Color(0,255,0);  // Yes
  //}
  
  //for(int PixelStart = StartGearLED; PixelStart < EndGearLED; PixelStart++) {
    //pixels.setPixelColor(PixelStart,Color);
  //}//for
//}
void HumanButton(bool HumanPlayerButton) {
  if (HumanPlayerButton == true) {
    if (millis() > (timeForHumanButton + 250)) {
      humanBlinkState = !humanBlinkState;
      timeForHumanButton = millis();
    }
    if (humanBlinkState == true) {
      for (int idxJ=0;humanLights[idxJ] != -1;idxJ++) {
       pixels.setPixelColor(humanLights[idxJ], pixels.Color(150,150,150));
      }
    }
  }
}
void PongGame() {
  int testLED = 32;
  if(millis() > (timeForPongStart + 3000)) {
    PaddlePos();
    BallLocation();
    DrawBall();
    Scoring();
  }
  else {
    for (int idxF=0;PongP[idxF] != -1;idxF++) {
       pixels.setPixelColor(PongP[idxF], pixels.Color(7,222,245));
    }
    for (int idxG=0;PongO[idxG] != -1;idxG++) {
       pixels.setPixelColor(PongO[idxG], pixels.Color(196,116,57));
    }
    for (int idxH=0;PongN[idxH] != -1;idxH++) {
       pixels.setPixelColor(PongN[idxH], pixels.Color(221,32,192));
    }
    for (int idxI=0;PongG[idxI] != -1;idxI++) {
       pixels.setPixelColor(PongG[idxI], pixels.Color(104,149,128));
    }
  }
}
void PaddlePos() {
      if (LeftPaddleUp) {
      if(millis() > (timeForLeftPaddle + 100)) {
      leftPosition++;
      timeForLeftPaddle = millis();
      }
      if (leftPosition > 4) {
        leftPosition = 4;
      }
    }
    if (LeftPaddleDown) {
      if(millis() > (timeForLeftPaddle + 100)) {
      leftPosition--;
      timeForLeftPaddle = millis();
      }
      if (leftPosition < 0) {
        leftPosition = 0;
      }
    }
    if (RightPaddleUp) {
      if(millis() > (timeForRightPaddle + 100)) {
      rightPosition++;
      timeForRightPaddle = millis();
      }
      if (rightPosition > 4) {
        rightPosition = 4;
      }
    }
    if (RightPaddleDown) {
      if(millis() > (timeForRightPaddle + 100)) {
      rightPosition--;
      timeForRightPaddle = millis();
      }
      if (rightPosition < 0) {
        rightPosition = 0;
      }
    }
   switch (leftPosition) {
      case 0:
       pixels.setPixelColor(0, pixels.Color(7,222,245));
       pixels.setPixelColor(37, pixels.Color(7,222,245));
       pixels.setPixelColor(38, pixels.Color(7,222,245));
       break;
      case 1:
        pixels.setPixelColor(37, pixels.Color(7,222,245));
        pixels.setPixelColor(38, pixels.Color(7,222,245));
        pixels.setPixelColor(75, pixels.Color(7,222,245));
        break;
      case 2:
        pixels.setPixelColor(38, pixels.Color(7,222,245));
        pixels.setPixelColor(75, pixels.Color(7,222,245));
        pixels.setPixelColor(76, pixels.Color(7,222,245));
        break;
      case 3:
        pixels.setPixelColor(75, pixels.Color(7,222,245));
        pixels.setPixelColor(76, pixels.Color(7,222,245));
        pixels.setPixelColor(113, pixels.Color(7,222,245));
        break;
      case 4:
        pixels.setPixelColor(76, pixels.Color(7,222,245));
        pixels.setPixelColor(113, pixels.Color(7,222,245));
        pixels.setPixelColor(114, pixels.Color(7,222,245));
        break;
    }
    switch (rightPosition) {
      case 0:
       pixels.setPixelColor(18, pixels.Color(7,222,245));
       pixels.setPixelColor(19, pixels.Color(7,222,245));
       pixels.setPixelColor(56, pixels.Color(7,222,245));
       break;
      case 1:
        pixels.setPixelColor(19, pixels.Color(7,222,245));
        pixels.setPixelColor(56, pixels.Color(7,222,245));
        pixels.setPixelColor(57, pixels.Color(7,222,245));
        break;
      case 2:
        pixels.setPixelColor(56, pixels.Color(7,222,245));
        pixels.setPixelColor(57, pixels.Color(7,222,245));
        pixels.setPixelColor(94, pixels.Color(7,222,245));
        break;
      case 3:
        pixels.setPixelColor(57, pixels.Color(7,222,245));
        pixels.setPixelColor(94, pixels.Color(7,222,245));
        pixels.setPixelColor(95, pixels.Color(7,222,245));
        break;
      case 4:
        pixels.setPixelColor(94, pixels.Color(7,222,245));
        pixels.setPixelColor(95, pixels.Color(7,222,245));
        pixels.setPixelColor(132, pixels.Color(7,222,245));
        break;
    }
  }
void BallLocation() {
  // if ball hasn't been 'shown' long enough, then wait some more
  if (millis() <= (timeForBallMove + deltaBall)) {
    return;
  }
  timeForBallMove = millis();
    
  // if not at a side, then move the ball
  if ((xBallPos > 1) && (xBallPos < 17)) {
    UpdateBallPos(true);
    return;
  }

  UpdateBallPos(false);
  
  // are we at the right edge?
  if (xBallPos >= 17) {
    if (IsAtPaddleTop(rightPosition)) {
      deltaBall -= 20;
      deltaY = 1;
      if (ballDirectionUp) {
        deltaX = 1;
      } else {
        deltaX = 2;
      }
      ballDirectionUp = true;
      yBallPos += deltaY;
    } else if (IsAtPaddleBottom(rightPosition)) {
      deltaBall -= 20;
      deltaY = 1;
      if (ballDirectionUp == false) {
        deltaX = 1;
      } else {
        deltaX = 2;
      }
      ballDirectionUp = false;
      yBallPos -= deltaY;
    } else if (IsAtPaddleMiddle(rightPosition)) {
      deltaBall -= 20;
      deltaY = 0;
      deltaX = 3;
    } else {
      leftScore = true;
      ScoreSystem();
      ResetBoard();
      return;
    }
    ballDirectionLeft = true;
    xBallPos = 17 - deltaX;
    if (yBallPos < 0) {
      yBallPos = 0;
    }
    if (yBallPos > 6) {
      yBallPos = 6;
    }
    return;
  }
  
  // are we are the left edge?
  if (xBallPos <= 1) {
    if (IsAtPaddleTop(leftPosition)) {
      deltaBall -= 20;
      deltaY = 1;
      if (ballDirectionUp) {
        deltaX = 1;
      } else {
        deltaX = 2;
      }
      ballDirectionUp = true;
      yBallPos += deltaY;
    } else if (IsAtPaddleBottom(leftPosition)) {
      deltaBall -= 20;
      deltaY = 1;
      if (ballDirectionUp == false) {
        deltaX = 1;
      } else {
        deltaX = 2;
      }
      ballDirectionUp = false;
      yBallPos -= deltaY;
    } else if (IsAtPaddleMiddle(leftPosition)) {
      deltaBall -= 20;
      deltaY = 0;
      deltaX = 3;
    } else {
      rightScore = true;
      ScoreSystem();
      ResetBoard();
      return;
    }
    ballDirectionLeft = false;
    xBallPos = 1 + deltaX;
    if (yBallPos < 0) {
      yBallPos = 0;
    }
    if (yBallPos > 6) {
      yBallPos = 6;
    }
    return;
  }
  
  // we are in the middle
}
bool IsAtPaddleTop(int Pos) {
  switch (Pos) {
      case 0:
        if (yBallPos == 2) {
          return true;
        }
        break;
      case 1:
        if (yBallPos == 3) {
         return true;
        } 
        break;
      case 2:
        if (yBallPos == 4) {
         return true; 
        }
        break;
      case 3:
        if (yBallPos == 5) {
         return true; 
        }
        break;
      case 4:
        if (yBallPos == 6) {
         return true; 
        }
        break;
  }
  return false;
}
bool IsAtPaddleBottom(int Pos) {
  switch (Pos) {
      case 0:
        if (yBallPos == 0) {
          return true;
        }
        break;
      case 1:
        if (yBallPos == 1) {
         return true;
        } 
        break;
      case 2:
        if (yBallPos == 2) {
         return true; 
        }
        break;
      case 3:
        if (yBallPos == 3) {
         return true; 
        }
        break;
      case 4:
        if (yBallPos == 4) {
         return true; 
        }
        break;
  }
  return false;
}
bool IsAtPaddleMiddle(int Pos) {
  switch (Pos) {
      case 0:
        if (yBallPos == 1) {
          return true;
        }
        break;
      case 1:
        if (yBallPos == 2) {
         return true;
        } 
        break;
      case 2:
        if (yBallPos == 3) {
         return true; 
        }
        break;
      case 3:
        if (yBallPos == 4) {
         return true; 
        }
        break;
      case 4:
        if (yBallPos == 5) {
         return true; 
        }
        break;
  }
  return false;
}
void FullReset() {
  randomSeed(millis());
  leftPosition = 2;
  rightPosition = 2;
  timeForPongStart = millis();
  timeForLeftPaddle = millis();
  timeForRightPaddle = millis();
  timeForBallMove = millis();
  ballDirectionLeft = (bool)random(0, 2);
  ballDirectionUp = (bool)random(0, 2);
  xBallPos = 9;
  yBallPos = 3;
  deltaX = 1;
  deltaY = random(0, 2);
  deltaBall = 250;
  leftPoints = 0;
  rightPoints = 0;
  timeForGameWin = 0;
}

void ResetBoard() {
  randomSeed(millis());
  leftPosition = 2;
  rightPosition = 2;
  timeForLeftPaddle = millis();
  timeForRightPaddle = millis();
  timeForBallMove = millis();
  ballDirectionLeft = (bool)random(0, 2);
  ballDirectionUp = (bool)random(0, 2);
  xBallPos = 9;
  yBallPos = 3;
  deltaX = 1;
  deltaY = random(0, 2);
  deltaBall = 250;
}
void DrawBall () {
  int ballPosition;
  switch (yBallPos) {
   case 0:
     ballPosition = xBallPos;
   break;
   case 1:
     ballPosition = 37 - xBallPos;
   break;
   case 2:
     ballPosition = xBallPos + 38;
   break;
   case 3:
     ballPosition = 75 - xBallPos;
   break;
   case 4:
     ballPosition = xBallPos + 76;
   break;
   case 5:
     ballPosition = 113 - xBallPos;
   break;
   case 6:
     ballPosition = xBallPos + 114;
   break;
  } 
   pixels.setPixelColor(ballPosition, pixels.Color(255,0,0));
}
void UpdateBallPos (bool inMiddle) {
 if (ballDirectionLeft) {
    // we are moving left
    if (yBallPos == 6) {
      // we hit the top
      ballDirectionUp = false;
      xBallPos -= deltaX;
      yBallPos -= deltaY;
    } else if (yBallPos == 0) {
      // we hit the bottom
      ballDirectionUp = true;
      xBallPos -= deltaX;
      yBallPos += deltaY;
    } else if (ballDirectionUp) {
      // we are in the middle and moving up
      xBallPos -= deltaX;
      yBallPos += deltaY;
    } else {
      // we are in the middle and moving down
      xBallPos -= deltaX;
      yBallPos -= deltaY;
    }
  }
  else {
    // we are moving right
    if (yBallPos == 6) {
      // we hit the top
      ballDirectionUp = false;
      xBallPos += deltaX;
      yBallPos -= deltaY;
    } else if (yBallPos == 0) {
       // we hit the bottom
       ballDirectionUp = true;
      xBallPos += deltaX;
      yBallPos += deltaY;
    } else if (ballDirectionUp) {
      // we are in the middle and moving up
      xBallPos += deltaX;
      yBallPos += deltaY;
    } else {
      // we are in the middle and moving down
      xBallPos += deltaX;
      yBallPos -= deltaY;
    }
  }
  
  // keep it on the screen
  if (yBallPos < 0) {
    yBallPos = 0;
  }
  if (yBallPos > 6) {
    yBallPos = 6;
  }
  if (inMiddle) {
    if (xBallPos > 17) {
      xBallPos = 17;
    }
    if (xBallPos < 1) {
      xBallPos = 1;
    }
  }
}
void ScoreSystem() {
  if (leftScore == true) {
    leftPoints ++;
    leftScore = false;
  }
  else if (rightScore == true) {
    rightPoints ++;
    rightScore == false;
  }
}
void Scoring() {
    //Left score System
  if (leftPoints == 1) {
      pixels.setPixelColor(133, pixels.Color(0,150,0));
      pixels.setPixelColor(134, pixels.Color(0,150,0));
  }
  else if (leftPoints == 2) {
      pixels.setPixelColor(133, pixels.Color(0,150,0));
      pixels.setPixelColor(134, pixels.Color(0,150,0)); 
      pixels.setPixelColor(135, pixels.Color(0,150,0));
      pixels.setPixelColor(136, pixels.Color(0,150,0));
  }
  else if (leftPoints == 3) {
    pixels.setPixelColor(133, pixels.Color(0,150,0));
    pixels.setPixelColor(134, pixels.Color(0,150,0));
    pixels.setPixelColor(135, pixels.Color(0,150,0));
    pixels.setPixelColor(136, pixels.Color(0,150,0));
    pixels.setPixelColor(137, pixels.Color(0,150,0));
    pixels.setPixelColor(138, pixels.Color(0,150,0));
 }
  //rigt Score System
  if (rightPoints == 1) {
     pixels.setPixelColor(144, pixels.Color(0,150,0));
     pixels.setPixelColor(143, pixels.Color(0,150,0));
  }
  else if (rightPoints == 2) {
     pixels.setPixelColor(144, pixels.Color(0,150,0));
     pixels.setPixelColor(143, pixels.Color(0,150,0));
     pixels.setPixelColor(142, pixels.Color(0,150,0));
     pixels.setPixelColor(141, pixels.Color(0,150,0));
  }
  else if (rightPoints == 3) {
     pixels.setPixelColor(144, pixels.Color(0,150,0));
     pixels.setPixelColor(143, pixels.Color(0,150,0));
     pixels.setPixelColor(142, pixels.Color(0,150,0));
     pixels.setPixelColor(141, pixels.Color(0,150,0));
     pixels.setPixelColor(140, pixels.Color(0,150,0));
     pixels.setPixelColor(139, pixels.Color(0,150,0));
  }
}
void WinnerScreen() {
     for (int AllPixels = 0; AllPixels < 165; AllPixels++) {
          pixels.setPixelColor(AllPixels, pixels.Color(0, 0, 0));
      }
      if(timeForGameWin == 0) 
        timeForGameWin = millis();

      if (leftPoints == 4) {
            for (int idxJ=0;Chris[idxJ] != -1;idxJ++) {
             pixels.setPixelColor(Chris[idxJ], pixels.Color(150,0,0));
        }
        if (millis() >= (timeForGameWin + 4000)) {
          FullReset();
      }
      }
      if (rightPoints == 4) {
        for (int idxK=0;Elliot[idxK] != -1;idxK++) {
             pixels.setPixelColor(Elliot[idxK], pixels.Color(150,0,0));
        }
        if (millis() >= (timeForGameWin + 4000)) {
          FullReset();
        }
      }
  }
