//#include "reader.h"
//
//#include <iostream>
//#include <fstream>
//#include <utility>
//#include <stdint.h>
//#include <string.h>
//#include <cstdlib>
//#include "basic.h"
//
//enum class TokenType {
//	Indent = 1000,
//	Heading = 4444,
//	FreeString = 5757,
//	Identifier = 2345,
//	Double = 8000,
//	Integer = 1579
//};
//
//typedef struct {
//	TokenType type;
//	std::string string;
//	double real = 0.0;
//	long integer = 0;
//} Token;
//
//std::string grabLineUpTo(const std::string& line, size_t* start, char target) {
//	size_t mx;
//	mx = line.find(target, *start);
//	if (mx == std::string::npos) {
//		mx = line.size();
//	}
//	std::string s = line.substr(*start, mx - *start);
//	*start = mx + 1;
//	return s;
//}
//
//ActionReader::ActionReader() {
//
//}
//
//void ActionReader::registerType(std::string identifier,
//		std::vector<Parameter> params, ActionCreator maker) {
//	if (types.count(identifier) > 0) {
//		std::cerr << "Error: Identifier >" << identifier << "< is duplicated"
//				<< std::endl;
//		return;
//	}
//	ConstructionControl p;
//	p.maker = maker;
//	p.params = params;
//	types[identifier] = p;
//}
//
////void printActionRecursively(Action* a, size_t indent) {
////	std::string ind(2*indent,'-');
////	std::cout << ind << a->getIndentifier() << std::endl;
////	SequentialGroup* sg = dynamic_cast<SequentialGroup*>(a);
////	if (sg) {
////		for (Action* a : sg->getActions()) {
////			printActionRecursively(a, indent+1);
////		}
////		return;
////	}
////	ParallelGroup* pg = dynamic_cast<ParallelGroup*>(a);
////	if (pg) {
////		for (Action* a : pg->getActions()) {
////			printActionRecursively(a, indent+1);
////		}
////		return;
////	}
////}
//
//std::vector<std::pair<std::string, Action*> > ActionReader::read(
//		std::istream& input) {
//// step one; tokenize
//	std::vector<Token> symbols;
//	std::string line;
//	while (std::getline(input, line)) {
//		size_t i = 0;
//		if (line[i] == '/') {
//			continue;
//		}
//		if (line[i] == '#') {
//			// heading case
//			Token ident;
//			ident.type = TokenType::Heading;
//			size_t min = line.find(' ', 1);
//			if (min == std::string::npos) {
//				ident.string = line.substr(1, line.size());
//			} else {
//				size_t max = line.find_last_not_of(' ');
//				if (max == min) {
//					ident.string = line.substr(min + 1, line.size() - min + 1);
//				} else {
//					ident.string = line.substr(min + 1, max - min);
//				}
//			}
//			symbols.push_back(ident);
//			continue;
//		}
//
//		// Main case
//		int indent = 0;
//		while (line[i] == '-' && i + 1 < line.size() && line[i + 1] == '-') {
//			i += 2;
//			indent++;
//		}
//		Token idt;
//		idt.type = TokenType::Indent;
//		idt.integer = indent;
//		symbols.push_back(idt);
//
//		if (i == line.size()) {
//			continue;
//		}
//
//// now we are in argument list
//		do {
//			Token current;
//			char s = line[i];
//			switch (s) {
//			case ' ':
//				i++;
//				break;
//			case '"':
//				// read block to next quote
//				i++;
//				current.string = grabLineUpTo(line, &i, '"');
//				current.type = TokenType::FreeString;
//				symbols.push_back(current);
//				break;
//			default:
//				// read block to next whitespace, subhandle
//				std::string capture = grabLineUpTo(line, &i, ' ');
//				char* end_ptr;
//				const char* cc = capture.c_str();
//
//				if (capture.find(".") == std::string::npos) {
//					long integral = std::strtol(cc, &end_ptr, 0);
//					if (end_ptr != cc) {
//						current.type = TokenType::Integer;
//						current.integer = integral;
//						symbols.push_back(current);
//						break;
//					}
//				}
//				double real = std::strtod(cc, &end_ptr);
//				if (end_ptr != cc) {
//					current.type = TokenType::Double;
//					current.real = real;
//					symbols.push_back(current);
//					break;
//				}
//				current.type = TokenType::Identifier;
//				current.string = capture;
//				symbols.push_back(current);
//				break;
//			}
//		} while (i < line.size());
//	}
//
//// step one point five: debug
//	for (Token t : symbols) {
//		std::cout << (int) t.type << ": " << t.integer << ", " << t.real
//				<< ", >" << t.string << "<" << std::endl;
//	}
//// step two: parse
//	// basically read through in order, caching the last stack of whatever (command, etc)
//	// so that we can read give useful error messages. Line numbers/characters would be nice from lex phase
//	std::vector<std::pair<std::string, Action*> > actions;
//
//	for (size_t i = 0; i < symbols.size(); i++) {
//		std::string currentDescription;
//		while (symbols[i].type != TokenType::Heading) {
//			if (symbols[i].type != TokenType::Indent) {
//				std::cerr << "Expected heading" << std::endl;
//			}
//			i++;
//		}
//		std::pair<std::string, Action*> mode;
//		mode.first = symbols[i].string;
//		mode.second = new SequentialGroup();
//
//		std::vector<Action*> foo;
//		i++;
//		while (symbols[i].type != TokenType::Heading) {
//#define ABORT(TEXT) { std::cerr << TEXT << std::endl; goto restart; }
//
//			if (symbols[i].type != TokenType::Indent) {
//				ABORT("Expected indent");
//			}
//			i++;
//			if (symbols[i].type != TokenType::Identifier) {
//				ABORT("Expected identifier");
//			}
//			std::string identifier = symbols[i].string;
//			if ((identifier == "parallel") || (identifier == "sequential")) {
//				// increase indent case (nested stuff)
//				// create a stack outside the loop, continue
//				ABORT("Code for this not yet written... :-(");
//			} else {
//				ConstructionControl ctrl = types[identifier];
//				std::vector<Option> options;
//				i++;
//				size_t counter = 0;
//				// Double, Integer, FreeString, Identifier
//				while (symbols[i].type != TokenType::Indent
//						|| symbols[i].type != TokenType::Heading) {
//					counter++;
//					if (counter > ctrl.params.size()) {
//						ABORT("More arguments than expected");
//					}
//
//					Option opt;
//					Token cur = symbols[i];
//					switch (cur.type) {
//					case TokenType::Identifier:
//						// TODO subset checking
//						if (ctrl.params[counter].t != Type::Option) {
//							ABORT("Expected option parameter");
//						}
//						opt.string = cur.string;
//						break;
//					case TokenType::Integer:
//						// TODO bounds checking
//						if (ctrl.params[counter].t != Type::Integer) {
//							ABORT("Expected integer parameter");
//						}
//						opt.integer = cur.integer;
//						break;
//					case TokenType::Double:
//						// TODO bounds checking
//						if (ctrl.params[counter].t != Type::Real) {
//							ABORT("Expected real parameter");
//						}
//						opt.real = cur.real;
//						break;
//					case TokenType::FreeString:
//						if (ctrl.params[counter].t != Type::String) {
//							ABORT("Expected string parameter");
//						}
//						opt.string = cur.string;
//						break;
//					default: {
//						ABORT("Not expected");
//					}
//						break;
//					}
//					options.push_back(opt);
//					i++;
//				}
//				// TODO make stack savvy
//				// it had better be
//				dynamic_cast<ActionGroup*>(mode.second)->add(
//						(*ctrl.maker)(options));
//			}
//		}
//
//		actions.push_back(mode);
//
//		restart: continue;
//#undef ABORT
//
//	}
//
//	actions.push_back(
//			std::pair<std::string, Action*>("HELLO", new SequentialGroup( {
//					new DelayAction(1.0),
//					new PrintAction("YO!") })));
//
//// step two point five: debug
//
////	for (auto x : actions) {
////		std::cout << "# " << x.first << std::endl;
//////		printActionRecursively(x.second, 0);
////	}
//
////  step three: return
//	return actions;
//}
//
