#include "autobase.h"
#include <iostream>

int AutoBaseAction::globalCount = -1;

AutoBaseAction::AutoBaseAction() :
				lifter(*ss.l),
				gripper(*ss.g),
				drive(*ss.d),
				rcpuller(*ss.p),
				actName() {
	runCount = 0;
}

AutoBaseAction::AutoBaseAction(std::string name) :
				lifter(*ss.l),
				gripper(*ss.g),
				drive(*ss.d),
				rcpuller(*ss.p),
				actName(name) {
	runCount = 0;
}

AutoBaseAction::Systems AutoBaseAction::ss = { 0, 0, 0, 0 };
void AutoBaseAction::setSystems(Drive* d, Gripper* g, Lifter* l, TinCanPuller* p) {
	ss.d = d;
	ss.g = g;
	ss.l = l;
	ss.p = p;
}

void AutoBaseAction::endOrderDebug() {
	globalCount = -1;
}

void AutoBaseAction::beginOrderDebug() {
	globalCount = 0;
}

void AutoBaseAction::preHook() {
	if (globalCount >= 0) {
		runCount = globalCount;
		globalCount++;
	}
}

void AutoBaseAction::postHook() {
	if (globalCount >= 0) {
		if (actName.empty()) {
			std::cout << "Action " << runCount << " done." << std::endl;
		} else {
			std::cout << actName << " (" << runCount << ") done." << std::endl;
		}
	}
}
