#pragma once

#include "actions/action.h"
#include <string>

class Lifter;
class Drive;
class Gripper;
class TinCanPuller;

class AutoBaseAction: public Action {
public:
	explicit AutoBaseAction();
	explicit AutoBaseAction(std::string name);
	static void setSystems(Drive*, Gripper*, Lifter*, TinCanPuller*);
	static void beginOrderDebug();
	static void endOrderDebug();
protected:
	/// Access to Lifter subsystem
	Lifter& lifter;
	/// Access to Gripper subsystem
	Gripper& gripper;
	/// Access to Drive subsystem
	Drive& drive;
	/// Access to RCpuller subsystem
	TinCanPuller& rcpuller;
private:
	void preHook() override;
	void postHook() override;
	typedef struct {
		Lifter* l;
		Gripper* g;
		Drive* d;
		TinCanPuller* p;
	} Systems;
	static Systems ss;

	std::string actName;
	int runCount;
	static int globalCount;
};
