#include "driveStraight.h"
#include "drive.h"

DriveStraight::DriveStraight(double cm) :
				AutoBaseAction(
						"Drive Straight dist=" + std::to_string(cm) + " cm") {
	distance = cm;
}

void DriveStraight::initialize() {
	if (distance == 999){
		//hack for RC auto.
		drive.autonDriveStraight(230, .8);
	}
	else if (distance == 998){
			//hack for RC auto.
			drive.autonRCDriveBack(-20, .8);
	}
	else {
	drive.autonDriveStraight(distance, .5);
	}
}
void DriveStraight::process() {
	// don't have to do anything, because the drive class handles it
}
bool DriveStraight::isFinished() {
	return drive.autonDone();
}
void DriveStraight::abort() {
	drive.autoDoNothing();
}

