#pragma once

#include "autobase.h"

/**
 * @brief Drive straight for a given distance
 */
class DriveStraight : public AutoBaseAction {
public:
	/**
	 * @brief Constructor
	 *
	 * @param cm Distance to move in centimeters. Positive distances are
	 *      forward, negative distances are backward.
	 */
	DriveStraight(double cm);
private:
	void initialize() override;
	void process() override;
	bool isFinished() override;
	void abort() override;

	double distance;
};
