#include "moveRC.h"
#include "rcpuller.h"

MoveRC::MoveRC(TinCanPuller::Direction reelDirection, double time) :
				AutoBaseAction(
						"Move Puller for t=" + std::to_string(time) + " in dir="
								+ ((reelDirection
										== TinCanPuller::Direction::kIn) ?
										"In" :
										((reelDirection
												== TinCanPuller::Direction::kOut) ?
												"Out" : "Stop"))) {
	direction = reelDirection;
	reeltime = time;
}

void MoveRC::initialize() {
	timer.Reset();
	rcpuller.reel(direction);
}
void MoveRC::process() {
}
bool MoveRC::isFinished() {
	bool fin =timer.Get() > reeltime;
	if (fin) {
		rcpuller.reel(TinCanPuller::Direction::kStop);
	}
	return fin;
}
void MoveRC::abort() {
	rcpuller.reel(TinCanPuller::Direction::kStop);
}
