#pragma once

#include "autobase.h"
#include "rcpuller.h"

/**
 * @brief Drive in a circular arc
 */
class MoveRC : public AutoBaseAction {
public:
	/**
	 * @brief Constructor
	 *
	 * @see Drive::autonDriveTurn
	 */
	MoveRC(TinCanPuller::Direction reelDirection, double time);
private:
	void initialize() override;
	void process() override;
	bool isFinished() override;
	void abort() override;
	TimerW timer;
	TinCanPuller::Direction direction;
	double reeltime;
};
