#pragma once

#include "base.h"

class PIDFA {
public:
	/**
	 * All values are time-normalized with base unit 1 second.
	 */
	PIDFA(real iP, real iI = 0, real iD = 0, real iF = 0, real iA = 0, real iContribCap=0);
	~PIDFA();
	void Reset();
	/**
	 * Please call regularly
	 *
	 * @param setX Setpoint for controller
	 * @param X Actual last value
	 * @param goalV Expected upcoming change in setpoint (only applies if A =/= 0)
	 */
	real getNextOutput(real setX, real X, real goalD = 0);
private:
	double lastTime;
	real P, I, D, F, A, iCap;
	real lastErr;
	real integral;
};
