#pragma once

#include "base.h"

class CubicProfile {
public:
	typedef struct {
		real vel;
		real acc;
		real jerk;
	} State;
	CubicProfile(real travel, real maxVelocity, real maxAcceleration,
			real maxJerk);
	State getState(real distanceLeft);
private:
	State getSubState(real x);
	bool threestage;
	real A, J, totalDist;
	real maxV, fullRampDist, v1, v2, d1, d2, tmid, a1;
	real iJx6, iA, AdJ;

};
