#pragma once

#include "systembase.h"
#include "lifter.h"
#include "gripper.h"
#include "drive.h"
#include "SerialPort.h"
#include "Task.h"
#include "controls.h"

class Lights : public SystemBase {
public:
	Lights(Drive&, Gripper&, Lifter&, Controls&);
	~Lights();

	void debug(Logger& logger) override;
	void initialize() override;
	void process() override;

	/**
	 * @brief Enable white blink mode (as driver-HP signal).
	 *
	 * @param blinking true for blink, false for regular
	 */
	void blinkMode(bool blinking);
private:
	Drive& drive;
	Gripper& gripper;
	Lifter& lifter;
	Controls& controls;
	Task serialWriter;
	ReentrantSemaphore semaphore;
	SerialPort Serial1;
	char output[2];
	static void callWriteToStream(uint32_t arg);
	void writeToStream();
};
