#pragma once

#include "systembase.h"
#include <string>
#include <vector>

/**
 * @brief %Controls logging of information from the other systems
 */
class Logging : public SystemBase {

public:
	Logging();
	~Logging();

	void initialize() override;
	void process() override;

	/**
	 * @brief Enable or disable output to dashboard on controls
	 *
	 * @param pleaseDo If this is true, the class will begin or continue
	 *    to send data to the dashboard. If false, it will cease.
	 */
	void setWritingToDashboard(bool pleaseDo);

	void periodic(const char*, ...);

	static void registerSystem(SystemBase* p);
	static void unregisterSystem(SystemBase* p);
private:
	bool writingToDashboard;
	std::vector<std::string> bundle;
	UDPLog udpOutput;
	double lastLogTime;
};
