#include "rcpuller.h"
#include "hardware.h"

TinCanPuller::TinCanPuller() :
				SystemBase("RCPuller"),
				Base(HardwareAccess::getInstance()) {
	desiredPower = 0.0;
}
TinCanPuller::~TinCanPuller() {

}

void TinCanPuller::initialize() {
	desiredPower = 0.0;
}
void TinCanPuller::process() {
	Base.setRCPullerMotorPower(desiredPower);
}

void TinCanPuller::reel(Direction out) {
	switch (out) {
	case Direction::kIn:
		desiredPower = -0.25;
		break;
	case Direction::kOut:
		desiredPower = 0.30;
		break;
	case Direction::kStop:
		desiredPower = 0.0;
		break;
	}
}
