#pragma once

class DoubleConstant {
public:
	DoubleConstant(double value, const char* name);
	~DoubleConstant();
	double get() const;
	/// Read current values from file & network
	static void LoadAll();
	/// Update current values from file & network
	static void UpdateAll();
private:
	DoubleConstant(const DoubleConstant&) = delete;
	void operator=(const DoubleConstant&) = delete;
	static void WriteAll();
	static bool ReadAll();
	static bool CheckAll();

	const double codeValue;
	const char* const name;
	double currentValue;
};

/// Macro with which to define DoubleConstants in a nice fashion
#define TuneableConstant(Name, DoubleValue) DoubleConstant Name((DoubleValue), "-" #Name)
