#include "logger.h"
#include <stdarg.h>
#include <string>
#include <string.h>
#include "systembase.h"

size_t LINE_LENGTH = 50;
size_t LINES = 50;
size_t BUFLEN = (LINE_LENGTH+1) * LINES;

Logger::Logger() {
	buffer = new char[BUFLEN+1];
	buffer[0] = '\0';
	head = 0;
}
Logger::~Logger() {
	delete[] buffer;
}

void addToBuffer(char* buffer, const char* string, size_t len, size_t& head, size_t max) {
	char* start = buffer + sizeof(buffer[0])*head;
	if (head + len >= max) {
		len = max - head;
	}
	strncpy(start, string, len);
	head += len;
}

void Logger::write(SystemBase* this_, const char* formatString, ...) {
	std::string line = std::string(this_->getName()) + ": ";

	char buf[LINE_LENGTH + 1];
	va_list args;
	va_start(args, formatString);
	vsnprintf(buf, LINE_LENGTH -line.length(), formatString, args);
	va_end(args);
	line += std::string(buf) + "\n";
	addToBuffer(buffer, line.c_str(), line.length(), head, BUFLEN);
}

const char* Logger::getText() {
	buffer[head] = '\0';
	return buffer;
}
