#pragma once

#include <stddef.h>

class UDPLog_p;

/**
 * @brief Broadcasts packets over a UDP port
 */
class UDPLog {
public:
	/**
	 * @brief Create a broadcast packet sender
	 * @param port UDP port to set to
	 */
	UDPLog(int port);
	~UDPLog();
	/**
	 * @brief Send a packet with given info
	 *
	 * Works just like printf, but automatically flushes packets out (no buffering).
	 *
	 * @param fmt Printf-style format string
	 * @param ... arguments to format string
	 */
	void log(const char* fmt, ...);
	void log(const char*, size_t l);
private:
	UDPLog_p* priv;
};
